from shapely.geometry import Point, LineString, Polygon
from matplotlib.pyplot import plot, show

ertelmes_vonal = LineString([[1, 2], [5, 6]])
ures_vonal = LineString()
ertelmes_vonal.is_empty # hamis
ures_vonal.is_empty # igaz

onmetszo_vonal = LineString([[0, 0], [1, 1], [1, -1], [0, 1]])
x, y = onmetszo_vonal.xy
plot(x, y)
show()
egyszeru_vonal = LineString([[0, 0], [1, 1], [0, 1], [-1, 0]])
x, y = egyszeru_vonal.xy
plot(x, y)
show()
onmetszo_vonal.is_simple # hamis
egyszeru_vonal.is_simple # igaz

furcsa_poligon = Polygon([[0, 0], [1, 1], [1, -1], [0, 1], [0, 0]])
x, y = furcsa_poligon.exterior.xy
plot(x, y)
show()
normalis_poligon = Polygon([[0, 0], [1, 1], [0, 1], [0, 0]])
x, y = normalis_poligon.exterior.xy
plot(x, y)
show()
furcsa_poligon.is_valid # hamis
normalis_poligon.is_valid # igaz

pont = Point(11, 2)
pont.geom_type # "Point"
ertelmes_vonal.geom_type # "LineString"
furcsa_poligon.geom_type # "Polygon"
ures_vonal.geom_type # "GeometryCollection"

pont.area # mindig 0
pont.length # mindig 0
len(pont) # hibát dob
ertelmes_vonal.area # mindig 0
ertelmes_vonal.length
normalis_poligon.area
normalis_poligon.length

print(pont.centroid) # önmaga
print(ertelmes_vonal.centroid)
print(normalis_poligon.centroid)
print(pont.boundary)
print(ertelmes_vonal.boundary)
print(normalis_poligon.boundary)
normalis_poligon.centroid.boundary.is_empty # igaz
ertelmes_vonal.boundary.geom_type # "MultiPoint"
normalis_poligon.boundary.length == normalis_poligon.length # igaz

pont = Point(3, 4)
vonal = LineString([[0, 0], [3, 2], [0, 5]])
type(pont.x) # valós szám
type(vonal.x) # csak pontok esetén értelmezett!
type(pont.y) # valós szám
type(pont.xy) # módosíthatatlan lista
pont.xy # ami a koordinátákat tömbökként (array) tartalmazza
type(vonal.xy) # tömbök módosíthatatlan listája
x, y = vonal.xy
x # ez az adatformátum kell a matplotlibes ábrázoláshoz
type(normalis_poligon.xy) # poligonok esetén nem értelmezett!
type(normalis_poligon.exterior.xy) # a határoló körvonalnak (.exterior) van .xy tulajdonsága

type(pont.coords) # speciális, iterálható formátum (CoordinateSequence)
type(vonal.coords) # speciális, iterálható formátum (CoordinateSequence)
type(normalis_poligon.coords) # hiba: "Component rings have coordinate sequences, but the polygon does not"
type(normalis_poligon.exterior.coords) # a határoló körvonalnak (.exterior) van .coords tulajdonsága

len(vonal.coords) # a hossza 3
list(vonal.coords) # összes koordinátapár (tuple) listája
vonal.coords[0] # az első elem koordinátapárja
vonal.coords[1:3] # a második és harmadik elemek koordinátapárjai listaként
vonal.coords[:] # összes koordinátapár (tuple) listája
for koordinatapar in vonal.coords:
    print(list(koordinatapar))
