from shapely.geometry import Point, LineString, Polygon
from matplotlib.pyplot import plot, show

tortvonal = LineString([[0, 0], [1, 1], [0, 2], [2, 2], [3, 1], [1, 0]])
puffer = tortvonal.buffer(0.5)
puffer.geom_type # "Polygon"
csokkentett = puffer.buffer(-0.3)
csokkentett.area < puffer.area # igaz

pont = Point(3, 4)
pont.convex_hull.geom_type # "Point"
tortvonal.convex_hull.geom_type # "Polygon"
befoglalo_sokszog = tortvonal.convex_hull
befoglalo_teglalap = tortvonal.envelope
x, y = tortvonal.xy
plot(x, y) # először a vonalláncot rajzoljuk meg
x, y = befoglalo_sokszog.exterior.xy
plot(x, y) # majd (új rétegként) a befoglaló sokszöget
x, y = befoglalo_teglalap.exterior.xy
plot(x, y) # utána pedig a befoglaló téglalapot
show() # végül megjelenítjük a három megrajzolt réteget

bal_kor = Point(1, 1).buffer(1.5)
jobb_kor = Point(2, 1).buffer(1.5)
unio = bal_kor.union(jobb_kor)
x, y = unio.exterior.xy
plot(x, y)
show()

metszet = bal_kor.intersection(jobb_kor)
x, y = metszet.exterior.xy
plot(x, y)
show()
a = LineString([[0, 0], [0, 5]])
b = LineString([[0, 3], [0, 7]])
c = LineString([[0, 5], [0, 7]])
d = LineString([[0, 3], [0, 7], [10, 3], [0, 0]])
print(a.intersection(b)) # LINESTRING (0 3, 0 5)
print(a.intersection(c)) # POINT (0 5)
print(a.intersection(d)) # GEOMETRYCOLLECTION (POINT (0 0), LINESTRING (0 3, 0 5))

kulonbseg1 = bal_kor.difference(jobb_kor)
kulonbseg2 = jobb_kor.difference(bal_kor)
kulonbseg1.intersection(kulonbseg2).geom_type # "MultiPoint", nem fednek át

szimmetrikus_kulonbseg = bal_kor.symmetric_difference(jobb_kor)
szimmetrikus_kulonbseg.area # 5.882071027177405
unio.area - metszet.area # kb. ugyanaz
kulonbseg1.area + kulonbseg2.area # kb. ugyanaz

Point(0, 0).distance(Point(1, 1)) # 1.414 (egységnégyzet átlója)
befoglalo_teglalap.distance(tortvonal) # ha összemetsződnek, akkor 0 a távolság
Polygon([[0, 0], [1, 0], [1, 1], [0, 1], [0, 0]]).distance(Point(3, 4))

a1 = LineString([[0, 0], [1, 1]])
a2 = LineString([[0, 0], [1, 1]])
b = LineString([[0, 0], [0.5, 0.5], [1, 1]])
c = LineString([[0, 0], [0, 0], [1, 1]])
a1.equals(a2) # igaz
a1 == a2 # igaz
a1.equals(b) # igaz (extra toresponttol fuggetlenul egybeesnek)
a1 == c # hamis
b.equals(c) # igaz
b == c # hamis

haromszog = Polygon([[0, 0], [1, 0], [0.5, 1]])
haromszog.contains(Point(0.5, 0.5)) # igaz
Point(0.5, 0.5).within(haromszog) # igaz
x, y = haromszog.exterior.xy
plot(x, y)
x, y = Point(0.4, 0).xy
plot(x, y, marker = "o")
show()
haromszog.contains(Point(0.4, 0)) # hamis, mert a határvonalra esik
haromszog.intersects(Point(0.4, 0)) # igaz
